## mingw-w64-doxygen-1.13.2-1.src.tar.zst

=== addon/doxmlparser/requirements.txt ===
lxml>=4.0.0
six>=1.0.0
